# $Revision: 1.26 $, $Date: 2009/06/09 18:30:33 $
# TODO
# - pick items from PLD-doc/RPM-loops.txt
%define		rev	%(R="$Revision: 1.26 $"; RR="${R##: }"; echo ${RR%%?})
Summary:	PLD Linux RPM macros dealing with loop errors
Name:		rpm-whiteout
Version:	%{rev}
Release:	1
License:	GPL
Group:		Base
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
PLD Linux RPM macros dealing with loop errors in RPM packages in PLD
Linux Distribution that can't solved easily or not wanted to be
solved.

%prep
%setup -qcT

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/rpm
cat <<'EOF' > $RPM_BUILD_ROOT/etc/rpm/macros.whiteout
#	Relations between package names that cause dependency loops
#	with legacy packages that cannot be fixed. Relations are
#	specified as
#		p>q
#	where package p has a Requires: on something that package q Provides:
#	so q is installed before p normally.
#
# Note: that there cannot be any whitespace within the string "p>q",
#	and that both p and q are package names (i.e. no version/release).

# Note: these are PACKAGE names, not Provide names.

%%_dependency_whiteout	\
	%%{_dependency_whiteouts_subpkg}	\
	php-pear-PEAR-core>php-pear-Console_Getopt \
	vim-rt>vim \
	vim-rt>vim-plugin-securemodelines \
	vim-rt>vim-syntax-spec \
	vim-rt>vim-syntax-poldek \
	java-sun-jre>java-sun-tools \
	glibc>nss-softokn-freebl \
	ZendFramework>ZendFramework-Zend_Date \
	ZendFramework>ZendFramework-Zend_Exception \
	ZendFramework>ZendFramework-Zend_Http \
	ZendFramework>ZendFramework-Zend_Loader \
	ZendFramework>ZendFramework-Zend_Registry \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Dojo \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Json \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Layout \
	ZendFramework-Zend_Controller>ZendFramework-Zend_Session \
	ZendFramework-Zend_Controller>ZendFramework-Zend_View \
	ZendFramework-Zend_Json>ZendFramework-Zend_Cache \
	ZendFramework-Zend_Layout>ZendFramework-Zend_View \
	kdelibs>kdelibs-shared \
	kdebase-desktop>kde-kside-PLD \
	kdebase-desktop>kde-logoutpic-PLD \
	kdebase-desktop>kde-splash-Default \
	konqueror>kdeaddons-fsview \
	konqueror>kdeaddons-konqueror \
	konqueror>kdemultimedia-audiocd \
	koffice-kexi>koffice-kspread \
	rc-scripts>blockdev \
	esound-libs>esound-alsa \
	initramfs-tools>cryptsetup-luks-initramfs \
	initramfs-tools>dmraid-initramfs \
	initramfs-tools>lvm2-initramfs \
	initramfs-tools>mdadm-initramfs \
	initramfs-tools>multipath-tools-initramfs \
	initramfs-tools>openct-initramfs \
	initramfs-tools>opensc-initramfs \
	initramfs-tools>udev-initramfs \
	gmplayer>mplayer-skin-KDE \
	QtGui>Qt3Support \
	QtGui>QtSvg \
%%{nil}

# dependency whiteouts if main pkg requires it's subpkg, this should be handed
# somehow in rpm itself, but for now keep the list.
%%_dependency_whiteouts_subpkg	\
	lighttpd>lighttpd-mod_dirlisting \
	lighttpd>lighttpd-mod_indexfile \
	lighttpd>lighttpd-mod_staticfile \
	glibc-misc>glibc \
	glibc-misc>glibc64 \
	glibc-localedb-all>glibc \
	gtk+2>gtk+2-cups \
	hal>hal-info \
	amarok>amarok-xine \
	util-vserver>vserver-distro-pld \
	util-vserver-build>vserver-distro-pld \
	roundcubemail>roundcubemail-skin-default \
%%{nil}

EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
# these should be replaced with an upgrade
%config %verify(not md5 mtime size) /etc/rpm/macros.whiteout

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: rpm-whiteout.spec,v $
Revision 1.26  2009/06/09 18:30:33  glen
- glibc-localedb-all>glibc

Revision 1.25  2009/05/25 21:00:06  glen
- glibc>nss-softokn-freebl whiteout

Revision 1.24  2009/03/19 09:29:25  glen
- old ac loop too for vserver-distro-pld

Revision 1.23  2009/03/16 21:51:57  arekm
- escape _dependency_whiteouts_subpkg macro

Revision 1.22  2009/03/16 18:31:29  glen
- package names

Revision 1.21  2009/03/16 18:27:06  glen
- roundcubemail skin loop

Revision 1.20  2009/03/02 16:38:23  glen
- some whiteouts

Revision 1.19  2009/02/26 23:57:19  glen
- perl-dirs>perl-base is fixed

Revision 1.18  2009/02/26 15:17:55  baggins
- added initramfs-tools

Revision 1.17  2008/12/06 20:35:09  glen
- PLD-doc/RPM-loops.txt has raw notes of loops

Revision 1.16  2008/12/06 19:53:22  glen
- separate list for main<>subpkg loops

Revision 1.15  2008/11/26 22:57:53  glen
- typo

Revision 1.14  2008/11/26 18:14:59  glen
- few subpkg loops

Revision 1.13  2008/11/24 15:21:45  glen
- add to whiteout one line per time, so they are not overused

Revision 1.12  2008/11/24 12:23:59  glen
- ZendFramework deps

Revision 1.11  2008/11/18 16:51:05  glen
- whiteout for 64bit ac glibc too

Revision 1.10  2008/11/13 10:01:42  glen
- glibc whiteout

Revision 1.9  2008/11/11 18:40:56  glen
- ca-certificates doesn't require openssl (anymore)

Revision 1.8  2008/11/11 18:36:41  glen
- java-sun whiteout

Revision 1.7  2008/11/01 18:31:47  baggins
- add openssl/ca-certificates loops

Revision 1.6  2008/10/27 10:23:30  glen
- reverse whiteout so that lighttpd is installed before it's modules

Revision 1.5  2008/10/07 09:41:06  glen
- lighttpd dep loops

Revision 1.4  2008/08/21 20:43:14  glen
- forgoten backslashes

Revision 1.3  2008/08/13 11:44:16  glen
- vim-syntax-*, vim-plugin-* whiteout

Revision 1.2  2008-05-29 18:55:08  glen
- forgot rel 1

Revision 1.1  2008-05-29 18:53:24  glen
- start keeping record of packages with loop errors
  this will solve .rpmsave/.rpmnew creation on transactions that install
  packages with dependency loops.
